<div class="p-2">
  <p-breadcrumb [home]="isEdit?
  {icon: 'pi pi-home', label: ' Sentencia', routerLink: '../../', queryParams: isView?{visualizar:true}:{}}:
  {icon: 'pi pi-home', label: ' Sentencia', routerLink: '../' }" [model]="[

  { icon: 'pi pi-book', label: asunto+' Tipo de violación por invasión de esferas analizado en la sentencia', routerLink: './',queryParams: isView?{visualizar:true}:{} }
  ]">
  </p-breadcrumb>
</div>
<form>
  <div class="card p-3">
    <div class="d-flex justify-content-between mt-2">
      <a [routerLink]="[isEdit?'../../':'../']" [queryParams]="isView?{visualizar:true}:{}">
        <p-button styleClass="p-button-sm back" label="Volver"></p-button>
      </a>
    </div>

    <div class="form-row">
      <div class="col-12" *ngIf="isEdit">
        <label for="">Tipo de violación por invasión de esferas:</label>
        <p-dropdown [options]="catalogos.violacionInvacionEsferasAnalizada" optionLabel="nombre" optionValue="nombre"
          placeholder="Seleccione el tipo de violación por invasión de esferas" styleClass="w-100" name="vioEsferas"
          id="vioEsferas" [(ngModel)]="violacionEsferas.tipoViolacionInvacionEsferas"></p-dropdown>
      </div>
      <div class="col-12" *ngIf="isEdit">
        <label for="">Acto(s) Impugnado(s):</label>
        <ng-multiselect-dropdown [settings]="configDropdown" [data]="actos" name="actos" id="actos"
          placeholder="Selecciona el acto(s) Impugnado(s)" [(ngModel)]="violacionEsferas.actosImpugnados">
        </ng-multiselect-dropdown>
      </div>
    </div>
  </div>
  <div class="card p-3" *ngIf="isEdit">
    <div class="form-row">
      <div class="col-12" >
        <div class="mb-2">
          <label for="">Rubro temático:</label>
          <textarea cols="30" rows="5" class="form-control" placeholder="Escribe aquí..." name="rubro" id="rubro"
            [(ngModel)]="rubro"></textarea>
          <div class="d-flex justify-content-end mt-2">
            <p-button [ngClass]="{'collapse': isView}" styleClass="p-button-sm"
              [label]="indexOfRubro !=-1 ? 'Actualizar rubro' :'Agregar rubro'"
              (onClick)="indexOfRubro != -1? actualizarRubro() : agregarRubroPrincipal()"></p-button>
          </div>
        </div>
        <label for="">Rubro(s) temático(s):</label>
        <p-orderList (onReorder)="orderRubro()" [value]="violacionEsferas.rubrosTematicosPrincipal"
          [listStyle]="{'max-height':'20rem'}" [dragdrop]="true">
          <ng-template let-rubrosTem pTemplate="item" let-i="index" ;>
            <div class="row">
              <div class="col-11">
                <p>{{ (i+1 | convertRomano) + '. '+ rubrosTem }}</p>
              </div>
              <div class="col-1 relative" style="z-index: 9;">
                <div class="d-flex justify-content-around align-items-center">
                  <i [ngClass]="{'collapse': isView}" class="pi pi-trash c-del"
                    (click)="deleteRubroPrincipal($event,i)"></i>
                  <i [ngClass]="{'collapse': isView}" class="pi pi-pencil" (click)="editRubroTematico(rubrosTem,i)"></i>
                </div>
              </div>
            </div>
          </ng-template>
        </p-orderList>
      </div>
    </div>
  </div>
  <div class="card p-3">
    <div class="form-row">
      <div class="col-12">
        <p-fieldset legend="Votación relacionada con la violación por invasión de esferas analizado en la sentencia">

          <div class="row">
            <div class="col-12">
              <label for="">Texto votación:</label>
              <textarea cols="10" rows="5" class="form-control" [(ngModel)]="violacionEsferas.textoVotacion"
                name="textoV" id="textoV"></textarea>
              <div class="d-flex justify-content-end mt-2">
                <p-button [ngClass]="{'collapse': isView}" styleClass="p-button-sm" label="Analizar texto"
                  (onClick)="processText()"></p-button>
              </div>
            </div>
            <label for="" class="col-12">Votación:</label>
            <div class="col-6">
              <div class="head-votacion d-flex px-3 py-1">
                <p-checkbox (onChange)="markAllFavor($event)"></p-checkbox>
                <p class="text-center w-100">Votación a favor ({{violacionEsferas.votacionFavor.length}})</p>
              </div>
              <div class="list p-2">
                <div [ngClass]="{'disabled':violacionEsferas.votacionEnContra.includes(vFavor)}"
                  class="list-item d-flex align-items-center" style="gap: 10px;"
                  *ngFor="let vFavor of violacionEsferas.ministros">
                  <p-checkbox name="group2" value="vFavor" [value]="vFavor" [(ngModel)]="violacionEsferas.votacionFavor"
                    [inputId]="vFavor+'favor'"></p-checkbox>
                  <label [for]="vFavor+'favor'" class="mb-0">{{vFavor}}</label>
                </div>
              </div>
            </div>
            <div class="col-6">
              <div class="head-votacion d-flex px-3 py-1">
                <p-checkbox (onChange)="markAllContra($event)"></p-checkbox>
                <p class="text-center w-100">Votación en contra ({{violacionEsferas.votacionEnContra.length}})</p>
              </div>
              <div class="list p-2">
                <div [ngClass]="{'disabled':violacionEsferas.votacionFavor.includes(vContra)}"
                  class="list-item d-flex align-items-center" style="gap: 10px;"
                  *ngFor="let vContra of violacionEsferas.ministros">
                  <p-checkbox name="group3" value="vContra" [value]="vContra"
                    [(ngModel)]="violacionEsferas.votacionEnContra" [inputId]="vContra+'contra'">
                  </p-checkbox>
                  <label [for]="vContra+'contra'" class="mb-0">{{vContra}}</label>
                </div>
              </div>
            </div>
            <div class="col-12">
              <p>Consideraciones aprobadas por ocho votos o más:</p>
              <p-inputSwitch [(ngModel)]="violacionEsferas.aprobadasConcideraciones" name="consideracion"
                id="consideracion">
              </p-inputSwitch>
            </div>
          </div>
        </p-fieldset>
      </div>
    </div>
  </div>
  <div class="card p-3">
    <div class="form-row">
      <div class="col-12" *ngIf="isEdit">
        <label for="">Sentido de la resolución:</label>
        <p-dropdown [options]="catalogos.sentidoResolucion" optionValue="nombre" optionLabel="nombre"
          placeholder="Selecciona el sentido de la resolución" name="sentido" id="sentido" styleClass="w-100"
          [(ngModel)]="violacionEsferas.sentidoResolucion"></p-dropdown>
      </div>
      <div class="col-12" *ngIf="isEdit">
        <label for="">Metodología de análisis de constitucionalidad:</label>
        <p-dropdown [options]="catalogos.analisisConstitucionlidad" id="metodologia" name="metodologia"
          optionValue="nombre" optionLabel="nombre" placeholder="Selecciona la metodología" styleClass="w-100"
          [(ngModel)]="violacionEsferas.metodologiaAnalisisConstitucionalidad"></p-dropdown>
      </div>
      <div class="col-12" *ngIf="violacionEsferas.sentidoResolucion != 'PARÁMETRO APROBADO' && isEdit">
        <label for="">Tipo de sentencia:</label>
        <ng-multiselect-dropdown placeholder="Seleccione el tipo de sentencia" [data]="catalogos.tipoSentencia"
          [settings]="configDropdown" name="tipoSentencia" id="tipoSentencia"
          [(ngModel)]="violacionEsferas.tipoSentencia"></ng-multiselect-dropdown>
      </div>
      <div class="col-12" *ngIf="violacionEsferas.sentidoResolucion === 'FUNDADA'">
        <label for="">Rubros temáticos relacionados con los efectos de la sentencia:</label>
        <p-table [value]="violacionEsferas.rubrosEfectoSentencia" [scrollable]="true" scrollHeight="200px"
          scrollDirection="both">
          <ng-template pTemplate="header">
            <tr>
              <th style="width:100px">Rubro</th>
              <th style="width:200px">Votación a favor</th>
              <th style="width:200px">Votación en contra</th>
              <th style="width:50px"></th>
            </tr>
          </ng-template>
          <ng-template pTemplate="body" let-rubro>
            <tr>
              <td style="width:100px">
                <p class="item-rubro">
                  <span *ngFor="let rub of rubro.rubrosTematicos">
                    {{ rub }}
                  </span>
                </p>
              </td>
              <td style="width:200px">
                <p class="item-rubro">
                  <span *ngFor="let favor of rubro.votacionFavor">
                    {{ favor }}
                  </span>
                </p>
              </td>
              <td style="width:200px">
                <p class="item-rubro">
                  <span *ngFor="let contra of rubro.votacionEnContra">
                    {{ contra }}
                  </span>
                </p>
              </td>
              <td style="width:50px">
                <i [ngClass]="{'collapse': isView}" class="pi pi-trash c-del mx-2"
                  (click)="deleteRubro($event,rubro,'efectos')"></i>
                <i [ngClass]="{'collapse': isView}" class="pi pi-pencil" (click)="edicionRubro(rubro,'efectos')"></i>
              </td>
            </tr>
          </ng-template>
        </p-table>
        <div class="d-flex justify-content-end mt-2">
          <p-button [ngClass]="{'collapse': isView}" styleClass="p-button-sm" label="Agregar rubro" [disabled]="!isEdit"
            (onClick)="displayRubros('efectos')"></p-button>
        </div>
      </div>
      <div class="col-12" *ngIf="violacionEsferas.tipoSentencia.includes('EXTENSIVA A NORMAS DIVERSAS')">
        <label for="">Rubros temáticos relacionados con la extensión de invalidez:</label>
        <p-table [value]="violacionEsferas.rubrosExtencionInvalidez" [scrollable]="true" scrollHeight="200px"
          scrollDirection="both">
          <ng-template pTemplate="header">
            <tr>
              <th style="width:100px">Rubro</th>
              <th style="width:200px">Votación a favor</th>
              <th style="width:200px">Votación en contra</th>
              <th style="width:50px"></th>
            </tr>
          </ng-template>
          <ng-template pTemplate="body" let-rubro>
            <tr>
              <td style="width:100px">
                <p class="item-rubro">
                  <span *ngFor="let rub of rubro.rubrosTematicos">
                    {{ rub }}
                  </span>
                </p>
              </td>
              <td style="width:200px">
                <p class="item-rubro">
                  <span *ngFor="let favor of rubro.votacionFavor">
                    {{ favor }}
                  </span>
                </p>
              </td>
              <td style="width:200px">
                <p class="item-rubro">
                  <span *ngFor="let contra of rubro.votacionEnContra">
                    {{ contra }}
                  </span>
                </p>
              </td>
              <td style="width:50px">
                <i [ngClass]="{'collapse': isView}" class="pi pi-trash c-del mx-2"
                  (click)="deleteRubro($event,rubro,'extension')"></i>
                <i [ngClass]="{'collapse': isView}" class="pi pi-pencil" (click)="edicionRubro(rubro,'extension')"></i>
              </td>
            </tr>
          </ng-template>
        </p-table>
        <div class="d-flex justify-content-end mt-2">
          <p-button [ngClass]="{'collapse': isView}" styleClass="p-button-sm" label="Agregar rubro" [disabled]="!isEdit"
            (onClick)="displayRubros('extension')"></p-button>
        </div>
      </div>
    </div>

    <div class="d-flex justify-content-between mt-2">
      <a [routerLink]="[isEdit?'../../':'../']" [queryParams]="isView?{visualizar:true}:{}">
        <p-button styleClass="p-button-sm back" label="Volver" icon="pi pi-angle-left"></p-button>
      </a>
      <p-button [ngClass]="{'collapse': isView}" styleClass="p-button-sm" [icon]="isEdit?'pi pi-book': 'pi pi-save'"
        [label]="isEdit?'Actualizar': 'Guardar'" (onClick)="isEdit? updateVotacion() :crearVotacion()"></p-button>
    </div>
  </div>
</form>
<app-rubros-tematicos (closeEditRubro)="getModalUpdateRubro($event)" [openModal]="configRubros"
  (closeRubro)="getModal($event)" [dataRubro]="rubrosEdit">
</app-rubros-tematicos>
<p-confirmPopup></p-confirmPopup>
